# Service de cryptographie

The modules described in this chapter implement various algorithms of a cryptographic nature. They are available at the discretion of the installation. Here's an overview:

- `hashlib` --- Secure hashes and message digests
  - Algorithmes de hachage
  - Usage
  - Constructors
  - Attributes
  - Hash Objects
  - Empreintes de messages de taille variable SHAKE
  - Calcul d'empreinte (ou hachage) de fichiers
  - Dérivation de clé
  - BLAKE2
    - Création d'objets de calcul d'empreinte
    - Constantes
    - Exemples
      - Hachage simple
      - Production de tailles d'empreintes différentes
      - Hachage avec clé – Code d'authentification de message
      - Hachage randomisé
      - Personnalisation
      - Mode Arbre
    - Crédits
- `hmac` --- Keyed-Hashing for Message Authentication
- `secrets` --- Generate secure random numbers for managing secrets
  - Nombres aléatoires
  - Génération de jetons
    - Combien d'octets mon jeton doit-il comporter ?
  - Autres fonctions
  - Recettes et bonnes pratiques